using System;
using System.Collections;
using System.Runtime.Serialization;
using System.ComponentModel;
using System.Collections.Generic;

namespace RDH.Data.Models
{
	[Serializable]
	[DataContract]
	public partial class ItemLot : BaseModel// IModel , INotifyPropertyChanged
    {
        #region Fields
        private Guid _key;
        private DateTime? _expdate;
        private string _lotno;
        private bool? _isactive;
        private bool? _isdelete;
        private Guid? _createby;
        private Guid? _itemkey;
        private bool? _flag;
        private DateTime? _clienttime;
        private DateTime? _servertime;
        private string _ext01;
        private string _ext02;
        private string _ext03;
        private string _ext04;
        private string _ext05;
        private string _ext06;
        private string _ext07;
        private string _ext08;
        private string _ext09;
        private string _ext10;
        private string _itemid;
        private Item _item; 
        #endregion

		#region Public Properties

        [DataMember]
        public virtual Guid Key
        {
            get { return _key; }
            set 
            {
                _key = value;
                OnPropertyChanged("Key");
            }
        }
        [DataMember]
        public virtual DateTime? ExpDate
        {
            get { return _expdate; }
            set 
            {
                _expdate = value;
                OnPropertyChanged("ExpDate");
            }
        }
        [DataMember]
        public virtual string LotNo
        {
            get { return _lotno; }
            set 
            {
                _lotno = value;
                OnPropertyChanged("LotNo");
            }
        }
        [DataMember]
        public virtual bool? IsActive
        {
            get { return _isactive; }
            set 
            {
                _isactive = value;
                OnPropertyChanged("IsActive");
            }
        }
        [DataMember]
        public virtual bool? IsDelete
        {
            get { return _isdelete; }
            set 
            {
                _isdelete = value;
                OnPropertyChanged("IsDelete");
            }
        }
        [DataMember]
        public virtual Guid? CreateBy
        {
            get { return _createby; }
            set 
            {
                _createby = value;
                OnPropertyChanged("CreateBy");
            }
        }
        [DataMember]
        public virtual Guid? ItemKey
        {
            get { return _itemkey; }
            set 
            {
                _itemkey = value;
                OnPropertyChanged("ItemKey");
            }
        }
        [DataMember]
        public virtual bool? Flag
        {
            get { return _flag; }
            set 
            {
                _flag = value;
                OnPropertyChanged("Flag");
            }
        }
        [DataMember]
        public virtual DateTime? ClientTime
        {
            get { return _clienttime; }
            set 
            {
                _clienttime = value;
                OnPropertyChanged("ClientTime");
            }
        }
        [DataMember]
        public virtual DateTime? ServerTime
        {
            get { return _servertime; }
            set 
            {
                _servertime = value;
                OnPropertyChanged("ServerTime");
            }
        }
        [DataMember]
        public virtual string Ext01
        {
            get { return _ext01; }
            set 
            {
                _ext01 = value;
                OnPropertyChanged("Ext01");
            }
        }
        [DataMember]
        public virtual string Ext02
        {
            get { return _ext02; }
            set 
            {
                _ext02 = value;
                OnPropertyChanged("Ext02");
            }
        }
        [DataMember]
        public virtual string Ext03
        {
            get { return _ext03; }
            set 
            {
                _ext03 = value;
                OnPropertyChanged("Ext03");
            }
        }
        [DataMember]
        public virtual string Ext04
        {
            get { return _ext04; }
            set 
            {
                _ext04 = value;
                OnPropertyChanged("Ext04");
            }
        }
        [DataMember]
        public virtual string Ext05
        {
            get { return _ext05; }
            set 
            {
                _ext05 = value;
                OnPropertyChanged("Ext05");
            }
        }
        [DataMember]
        public virtual string Ext06
        {
            get { return _ext06; }
            set 
            {
                _ext06 = value;
                OnPropertyChanged("Ext06");
            }
        }
        [DataMember]
        public virtual string Ext07
        {
            get { return _ext07; }
            set 
            {
                _ext07 = value;
                OnPropertyChanged("Ext07");
            }
        }
        [DataMember]
        public virtual string Ext08
        {
            get { return _ext08; }
            set 
            {
                _ext08 = value;
                OnPropertyChanged("Ext08");
            }
        }
        [DataMember]
        public virtual string Ext09
        {
            get { return _ext09; }
            set 
            {
                _ext09 = value;
                OnPropertyChanged("Ext09");
            }
        }
        [DataMember]
        public virtual string Ext10
        {
            get { return _ext10; }
            set 
            {
                _ext10 = value;
                OnPropertyChanged("Ext10");
            }
        }
        [DataMember]
        public virtual string ItemId
        {
            get { return _itemid; }
            set 
            {
                _itemid = value;
                OnPropertyChanged("ItemId");
            }
        }
        [DataMember]
        public Item Item
        {
            get { return _item; }
            set 
            {
                _item = value;
                OnPropertyChanged("Item");
            }
        }
		#endregion 
        public ItemLot Clone()
        {
            return new ItemLot()
            {
                _clienttime = this._clienttime,
                _createby = this._createby,
                _createtime = this._createtime,
                _expdate = this._expdate,
                _ext01 = this._ext01,
                _ext02 = this._ext02,
                _ext03 = this._ext03,
                _ext04 = this._ext04,
                _ext05 = this._ext05,
                _ext06 = this._ext06,
                _ext07 = this._ext07,
                _ext08 = this._ext08,
                _ext09 = this._ext09,
                _ext10 = this._ext10,
                _flag = this._flag,
                _isactive = this._isactive,
                _isdelete = this._isdelete,
                _itemid = this._itemid,
                _itemkey = this._itemkey,
                _key = this._key,
                _lotno = this._lotno,
                _servertime = this._servertime,
            };
        }
	}
}